﻿using BepInEx;
using RoR2;
using System;
using System.Security;
using System.Security.Permissions;
using System.Threading.Tasks;
using System.Linq;
using MonoMod.Cil;
using MonoMod.RuntimeDetour;
using System.Collections.Generic;
using R2API;
using static R2API.RecalculateStatsAPI;

[module: UnverifiableCode]
[assembly: SecurityPermission(SecurityAction.RequestMinimum, SkipVerification = true)]

namespace HolyHolyHoly
{
    [BepInPlugin("xyz.yekoc.Holy", "HolyHolyHOLY","1.0.0" )]
    [BepInDependency("com.bepis.r2api",BepInDependency.DependencyFlags.HardDependency)]
    public class HolyPlugin : BaseUnityPlugin
    {
	public class HolyData{
	  public StatHookEventArgs args;
	  public bool OnLevel;
	  public bool statsDirty;
	}
	ILHook sprint,ih;
	Hook h;
	static Dictionary<CharacterBody,HolyData> queue = new Dictionary<CharacterBody,HolyData>();
	ILContext.Manipulator Taskifier = ((il) => {
		ILCursor c = new ILCursor(il);
		while(c.TryGotoNext(x => x.MatchCallOrCallvirt(typeof(CharacterBody).GetMethod("RecalculateStats")))){
		 c.Remove();
		 c.EmitDelegate<Action<CharacterBody>>((cb) => {if(!queue.ContainsKey(cb)) queue.Add(cb,new HolyData()); queue[cb].statsDirty = true; cb.statsDirty = false;});
		}
	  });

	private void Awake(){
	  IL.RoR2.CharacterBody.FixedUpdate += Taskifier;
	  //IL.RoR2.CharacterBody.Start += Taskifier; //Causes Instant Death on spawn.
	  IL.RoR2.CharacterMaster.OnBodyStart += Taskifier;
	  IL.RoR2.CharacterBody.OnCalculatedLevelChanged += OnLevelUp;
	  sprint = new ILHook(typeof(CharacterBody).GetProperty("isSprinting").GetSetMethod(),Taskifier);
	  if(RecalculateStatsAPI.Loaded){
		ih = new ILHook(((Action<ILContext>)RecalculateStatsAPI.HookRecalculateStats).Method,RecalculateStatsAPIRuiner);
		h = new Hook(((Action<CharacterBody>)RecalculateStatsAPI.GetStatMods).Method,((Action<Action<CharacterBody>,CharacterBody>)RecalculateStatsAPIRuiner2).Method);
	  }
	}

	private void OnDestroy(){
	  IL.RoR2.CharacterBody.FixedUpdate -= Taskifier;
	  IL.RoR2.CharacterMaster.OnBodyStart -= Taskifier;
	  IL.RoR2.CharacterBody.OnCalculatedLevelChanged -= OnLevelUp;
	  sprint.Undo();
	  if(RecalculateStatsAPI.Loaded){
	    h.Undo();
	    ih.Undo();
	  }
	}

	private void OnLevelUp(ILContext il){
		ILCursor c = new ILCursor(il);
		if(c.TryGotoNext(x => x.MatchRet())){
		 c.Index -= 1;
		 c.Remove();
		 c.EmitDelegate<Action<CharacterBody>>((CharacterBody cb) => {if(!queue.ContainsKey(cb)) queue.Add(cb,new HolyData()); queue[cb].OnLevel = true;});
		}
	}

	private void RecalculateStatsAPIRuiner(ILContext il){
				ILCursor c = new ILCursor(il);
				c.GotoNext(x=> x.MatchCallOrCallvirt(typeof(ILCursor).GetMethod("EmitDelegate").MakeGenericMethod(typeof(Action<CharacterBody>))),x=>x.MatchPop());
				c.GotoPrev(MoveType.After,x => x.MatchPop());
				c.Index++;
				c.RemoveRange(5);
				c.EmitDelegate<Action<ILCursor>>((cursor) => {cursor.EmitDelegate<Func<CharacterBody,StatHookEventArgs>>((body) => {if(!queue.ContainsKey(body)) RecalculateStatsAPI.GetStatMods(body);  return queue[body].args;});});
	}
	static private void RecalculateStatsAPIRuiner2(Action<CharacterBody> orig,CharacterBody cb){
				orig(cb);
				if(!queue.ContainsKey(cb))
				 queue.Add(cb,new HolyData());
				queue[cb].args = RecalculateStatsAPI.StatMods;
	}
	private void FixedUpdate(){
		if(Run.instance){
		 foreach(CharacterBody body in queue.Keys.ToList()){
		   if(body.healthComponent && body.healthComponent.alive){
		     if(RecalculateStatsAPI.Loaded && queue[body].statsDirty){
		      RecalculateStatsAPI.GetStatMods(body);
		     }
		   }
		   else{
		     queue.Remove(body);
		   }
		 }
		Parallel.ForEach(queue.Keys.Where((b) => queue[b].statsDirty), body =>{
			  body.RecalculateStats();
		});
		foreach(var pair in queue){
			if(pair.Value.OnLevel && pair.Key.healthComponent)
			   pair.Key.OnLevelUp();
			pair.Value.statsDirty = false;
			pair.Value.OnLevel = false;
		}
	 }
	}
    }
}
